local function getMount(msg) -- Location check function
	if GetCurrentMapContinent()==7 then -- Check if Player is in Draenor
		msg = msg:gsub("%[.-flyable.-%]",function(c) -- Find "flyable" in a macro
		return c:gsub("flyable","stance:9") -- Change "flyable" to "stance:9", forces [flyable] to return false in Draenor
		end)
		if GetZoneText()=="Nagrand" then -- Check if Player is in Nagrand
			msg = msg:gsub("%[.-nagrand.-%]",function(n) -- Find "nagrand" in a macro
			return n:gsub("nagrand","outdoors")end) -- Change "nagrand" to "outdoors"
		else -- If Player is NOT in Nagrand
			msg = msg:gsub("%[.-nagrand.-%]",function(n) -- Find "nagrand" in a macro
			return n:gsub("nagrand","stance:9")end) -- Change "nagrand" to "stance:9", forces [nagrand] to return false in other zones
		end
	else -- If Player is NOT in Draenor
				for i=1,138 do
				local _,_,body = GetMacroInfo(i)
				if body and body:match("/mount") then
					msg = msg:gsub("%[.-nagrand.-%]",function(n) -- Find "nagrand" in a macro
					return n:gsub("nagrand","stance:9")end) -- Change "nagrand" to "stance:9", forces [nagrand] to return false in other continents, preserves functionality in Outland-Nagrand
					end
				end
			end
--[[	if GetRealZoneText()==("Kelp'Thar Forest" or "Shimmering Expanse" or "Abyssal Depths") -- Check if Player is in Vashj'ir (NYI)
		msg = msg:gsub("%[.-vashjir.-%]",function(s) -- Find "vashjir" in a macro
		return s:gsub("vashjir","swimming")end) -- Change "vashjir" to "swimming"
		end]]
	return SecureCmdOptionParse(msg)
end

SlashCmdList["MOUNT"] = function(msg) -- Creates the MOUNT Slash Command Handler
	local mount = getMount(msg) -- Sets local "mount" to the spell returned by the Location Check Function
		if mount then -- Checks that the Location Check Function returned a non-nil string
			CastSpellByName(mount) -- Attaches the string from the Location Check Function to the MOUNT Slash Command Handler
		end
	end
SLASH_MOUNT1 = "/mount" -- Creates the "/mount" command

SlashCmdList["VEHICLEEXIT"] = function()
	if CanExitVehicle() then
		VehicleExit()
	end
	if IsMounted() then
		if IsModifierKeyDown() then
			Dismount()
		elseif not (IsFlying()) then
			if not((UnitAura("player","Telaari Talbuk")) or (UnitAura("player","Frostwolf War Wolf"))) then
				Dismount()
			end
		end
	end
end
SLASH_VEHICLEEXIT1 = "/ve"

local function updateIcons() -- Update the tooltip to the appropriate mount
	for i=1,138 do
	local _,_,body = GetMacroInfo(i)
		if body and body:match("/mount") then -- Checks all macros for the "/mount" command
			local cmd = body:match("/mount (.-)\n" or body:match("/mount (.-)$")) -- Returns the text of the "/mount" command
			SetMacroSpell(i,getMount(cmd)) -- Sets the tooltip to the appropriate mount
		end
	end
end

local function eventhandler(self,event,...) -- Triggers the tooltip update
	updateIcons()
	if event==PLAYER_ENTERING_WORLD then
		C_Timer.After(5,updateIcons())
	end
end

local frame = CreateFrame("FRAME", "Mount") -- Registering Events to update the tooltip
	frame:RegisterEvent("PLAYER_ENTERING_WORLD") -- Fires any time you exit a load screen
	frame:RegisterEvent("UPDATE_MACROS") -- Fires when you save changes to a macro
	frame:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE") -- Fires when you get a system chat message, ex. [Joined 1. General - Garrison]
--	frame:RegisterEvent("MODIFIER_STATE_CHANGED") -- Fires when you press Ctrl, Shift, or Alt. NYI.
	frame:SetScript("OnEvent",eventhandler) -- Calls the eventhandler